﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.5
@EndOfDesignText@
#Event: MouseMoved(X as Int, Y as Int)
Sub Class_Globals
	Private fx As JFX
	Private MPTimer As Timer
	Private MouseInfo As JavaObject
	Private MouseMoved As Boolean
	Private mCallBack As Object
	Type MousepointerType(X As Int, Y As Int)
	Private MPT As MousepointerType
	Private TargetForm As Form
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Callback As Object, F As Form)
	mCallBack = Callback
	TargetForm = F
	MPTimer.Initialize("MPTimer",100)
	MouseInfo.InitializeStatic("java.awt.MouseInfo")
	MouseMoved = SubExists(mCallBack,"AWTMousePointer_MouseMoved")
	MPT.Initialize
	MPTimer.Enabled = True
End Sub

Private Sub MPTimer_Tick
	Dim Location As JavaObject = MouseInfo.RunMethodJO("getPointerInfo",Null).RunMethodJO("getLocation",Null)
	Dim NewMPT As MousepointerType
	NewMPT.Initialize
	NewMPT.X = Location.RunMethod("getX",Null)
	NewMPT.Y = Location.RunMethod("getY",Null)
	
	If NewMPT.X = MPT.X And NewMPT.Y = MPT.Y Then Return
	
	MPT = NewMPT
	
	If MouseMoved And OverWindow(MPT) Then 
		CallSub3(mCallBack,"AWTMousePointer_MouseMoved",(MPT.x - TargetForm.WindowLeft).As(Int), (MPT.Y - TargetForm.WindowTop).As(Int))
	End If
	
End Sub

Private Sub OverWindow(TMPT As MousepointerType) As Boolean
	
	If TMPT.X >= TargetForm.WindowLeft And _
	TMPT.X <= TargetForm.WindowLeft + TargetForm.WindowWidth And _
	TMPT.Y >= TargetForm.WindowTop And _
	TMPT.Y <= TargetForm.WindowTop + TargetForm.WindowHeight Then
		Return True
	Else
		Return False
	End If
	
End Sub